#include "Driver_ADNS2610.h"

void ADNS_reset(void) {
	//ADNS_write(0x00,0x80);
	delay(1000);
	ADNS_write(0x00,0x01);
}

void ADNS_write(uint8_t address, uint8_t data)
{
	// take the CS pin low to select the chip:
	SPI_nCS_LOW();
	// send in the address and value via SPI:
	SPI_write(address | 0x80);
	SPI_write(data);
	delay_us(delay_tSWW);
	// take the SS pin high to de-select the chip:
	SPI_nCS_HIGH();
}

uint8_t ADNS_read(uint8_t address)
{
	uint8_t data;
	// take the CS pin low to select the chip:
	SPI_nCS_LOW();
	// send in the address and value via SPI:
	SPI_write(address);

	SPI_SDIO_Mode_INPUT();
	delay_us(delay_tSRAD);
	data = SPI_receive();
	SPI_SDIO_Mode_OUTPUT();
	// take the SS pin high to de-select the chip:
	SPI_nCS_HIGH();
	return data;
}
