#include "program.h"
#include "platform_config.h"

void init_setup(void)
{
  
    SPI_init();
#if defined(flg_serial_debug)
#if !defined(__AVR_ATtiny85__)
    Serial.begin(SERIAL_SPEED);
#else
    MyDbgSerial.begin(SERIAL_SPEED);
    //MyDbgSerial.println(F("\nDebug enabled"));
#endif
#endif



    //delay_ms(1);
    configurePinAsOutput(13);
    setPin(13);
    while(1);
    
    
    ADNS_reset();
    
}

void main_loop(void)
{
#ifndef flg_serial_debug
//-----------------------------------------------------------------------
    unsigned int data;
    while(1)
    {
        //data = ADNS_read(squal);
        //data = ADNS_read(Maximum_Pixel);
        //data = ADNS_read(Pixel_Sum);
        data = ADNS_read(Shutter_Upper)*256 + ADNS_read(Shutter_Lower);
    }
//-----------------------------------------------------------------------
#endif
#if flg_serial_debug ==1
//-----------------------------------------------------------------------
    byte Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+6+20];

    Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+6+20] = 0xff;	// frame data is 0..63 or 0..127 so delimiter 255 is safe

    while(1)
    {
        ADNS_write(0x00,0x01); //Always awake
        // grab frame and write to serial
        //reset the pixel grab counter
        ADNS_write(Pixel_Grab,0x00);

        for (int count=0; count < (ARRAY_WIDTH * ARRAY_HEIGHT); count++)
        {
            while(1)
            {
                Frame[count] = ADNS_read(Pixel_Grab);
                if(Frame[count] & Pixel_data_valid) break;
            }
            Frame[count] &= Mask_pixel_value;	// only n bits are used for data
        }

        for (int count=0; count < (ARRAY_WIDTH * ARRAY_HEIGHT); count++)
        {
            if (Frame[count] == 0xC0)
            {
                Serial.write(0xDB);
                Serial.write(0xDC);
            }
            else if (Frame[count] == 0xDB)
            {
                Serial.write(0xDB);
                Serial.write(0xDD);
            }
            else
            {
                Serial.write(Frame[count]);
            }
        }
        Serial.write(ADNS_read(squal));
        Serial.write(ADNS_read(Maximum_Pixel));
        Serial.write(ADNS_read(Minimum_Pixel));
        Serial.write(ADNS_read(Pixel_Sum));

        byte data[2];
        unsigned int shut;
        data[0] = ADNS_read(Shutter_Upper);
        data[1] = ADNS_read(Shutter_Lower);

        Serial.write(data[0]);
        Serial.write(data[1]);
        Serial.write(0xC0);

        shut = data[0]*256 + data[1];
    }
//-----------------------------------------------------------------------
#endif
#if flg_serial_debug ==2
//-----------------------------------------------------------------------
    byte Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+1];

    Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+1] = 0xff;	// frame data is 0..63 or 0..127 so delimiter 255 is safe
    byte data;
    while(1)
    {
        //data = ADNS_read(squal);
        data = ADNS_read(Maximum_Pixel);
        //data = ADNS_read(Pixel_Sum);

        if(data > 120)
        {
            pin_led_HIGH;
        }
        else
        {
            pin_led_LOW;

            // grab frame and write to serial
            //reset the pixel grab counter
            ADNS_write(Pixel_Grab,0x00);

            for (int count=0; count < (ARRAY_WIDTH * ARRAY_HEIGHT); count++)
            {
                while(1)
                {
                    Frame[count] = ADNS_read(Pixel_Grab);
                    if(Frame[count] & Pixel_data_valid) break;
                }
                Frame[count] &= Mask_pixel_value;	// only n bits are used for data
            }
            MyDbgSerial.write(Frame, (ARRAY_WIDTH * ARRAY_HEIGHT)+1); // send frame in raw format
        }
    }
//-----------------------------------------------------------------------
#endif
#if flg_serial_debug ==3
//-----------------------------------------------------------------------
    byte Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+1];

    Frame[(ARRAY_WIDTH * ARRAY_HEIGHT)+1] = 0xff;	// frame data is 0..63 or 0..127 so delimiter 255 is safe
    while(1)
    {
        Frame[0] = ADNS_read(squal);
        Frame[1] = ADNS_read(Maximum_Pixel);
        Frame[2] = ADNS_read(Minimum_Pixel);
        Frame[3] = ADNS_read(Pixel_Sum);
        Frame[4] = ADNS_read(Shutter_Upper);
        Frame[5] = ADNS_read(Shutter_Lower);

        if (Frame[1] == 63)
        {
            digitalWrite(8, HIGH);
            Serial.println("Out high!");
        }
        else
        {
            pin_led_LOW;
            digitalWrite(8, LOW);
            Serial.println("Out low!");
        }

#if !defined(__AVR_ATtiny85__)
        Frame[1] >120 ? pin_led_HIGH : pin_led_LOW;
        Serial.println 			("squal: "	+ String(Frame[0]) + \
                                 "\tMax_Pix:"	+ String(Frame[1]) + \
                                 "\tMin_Pix:"	+ String(Frame[2]) + \
                                 "\tPix_Sum:"	+ String(Frame[3]) + \
                                 "\tShutter:"	+ String(Frame[4]) + \
                                 String(Frame[5]));
        delay(50);
#else
        MyDbgSerial.print	(F("squal: "));
        MyDbgSerial.write(ByteToAscii_h(Frame[0]));
        MyDbgSerial.write(ByteToAscii_l(Frame[0]));
        MyDbgSerial.print	(F("\tMax_Pix:"));
        MyDbgSerial.write(ByteToAscii_h(Frame[1]));
        MyDbgSerial.write(ByteToAscii_l(Frame[1]));
        MyDbgSerial.print	(F("\tMin_Pix:"));
        MyDbgSerial.write(ByteToAscii_h(Frame[2]));
        MyDbgSerial.write(ByteToAscii_l(Frame[2]));
        MyDbgSerial.print	(F("\tPix_Sum:"));
        MyDbgSerial.write(ByteToAscii_h(Frame[3]));
        MyDbgSerial.write(ByteToAscii_l(Frame[3]));
        MyDbgSerial.print	(F("\tShutter:"));
        MyDbgSerial.write(ByteToAscii_h(Frame[4]));
        MyDbgSerial.write(ByteToAscii_l(Frame[4]));
        MyDbgSerial.write(ByteToAscii_h(Frame[5]));
        MyDbgSerial.write(ByteToAscii_l(Frame[5]));
        if(Frame[1] >120)
        {
            MyDbgSerial.print(F("\tOk"));
        }
        MyDbgSerial.println(F(""));
        delay(100);	//�������� ������ ��-�� ������ �������� Digispark
#endif
    }
//-----------------------------------------------------------------------
#endif
#if flg_serial_debug ==4
//-----------------------------------------------------------------------
    while(1)
    {
        unsigned int motion = 0;
        //check for movement
        motion = ADNS_read(Motion);
        if(motion > 127)
        {
            //there has been a motion! Print the x and y movements
            MyDbgSerial.println("X:" + String(ADNS_read(Delta_X)) + " Y:" + String(ADNS_read(Delta_Y)));
        }
    }
//-----------------------------------------------------------------------
#endif
}
